//	ATtiny13A
//	CRCUIC TA2078PRg[

/*
|[gΉ	[ATtiny13A]	x:݂Ȃ(PB5RESET) -:
bit		7	6	5	4	3	2	1	0
portB	x	x	x	LC	sw	LED	LED	LED		PB4LED_Rg[

q[Yrbg(avrsp.exe -rf)
Low: -1101010
     ||||||++-- CKSEL[1:0] VXeNbNI
     ||||++-- SUT[1:0] N
     |||+-- CKDIV8 NbNl (1:1/1, 0:1/8)
     ||+-- WDTON (WDT 0:펞ON, 1:ʏ)
     |+-- EESAVE (ChipEEPROM 0:ێ, 1:)
     +-- SPIEN (1:ISP֎~, 0:ISP) HVŜ

High:---11111
        ||||+-- RSTDISBL (RESETs 1:L, 0:(PB5))
        ||++-- BODLEVEL[1:0] (11:Off, 10:1.8V, 01:2.7V, 00:4.3V)
        |+-- DWEN (On-ChipfobO 1:, 0:L)
        +-- SPMEN (SPM 1:, 0:L)

rh
WinAVR-20080610		œKIvV:-Os
ATtiny13A	l1.2MHzi9.6MHz8jcvOCLKPRɂĕύXB


2010/04/24	v1.00	Program:     214 bytes (20.9% Full)
				E
*/


#include	<avr/io.h>
#include	<avr/eeprom.h>


//EEPROM̃u[Xg^CṽAhX
#define	ADRS_BOOSTTYPE	0x00

//|[gݒ
#define	BIT_CTRLA		(1 << PB0)
#define	BIT_CTRLB		(1 << PB1)
#define	BIT_LED_ROCK	BIT_CTRLA
#define	BIT_LED_CLASSIC	BIT_CTRLB
#define	BIT_LED_POP		(1 << PB2)
#define	BIT_SW			(1 << PB3)
#define	BIT_LED_CTRL	(1 << PB4)
#define	BIT_LED_MASK	(BIT_LED_CTRL | BIT_LED_ROCK | BIT_LED_POP | BIT_LED_CLASSIC)

enum	E_BOOSTTYPE
{
	EBT_NORMAL,
	EBT_ROCK,
	EBT_POP,
	EBT_CLASSIC,
	EBT_IDX_END
};


int	main(void)
{
	uint8_t	sw, psw;		//XCb`ǂݎ
	uint8_t	swBT;			//XCb`̏	0:on	0:off
	uint8_t	loopCount;		//^C~O҂ȂǂɎgJE^	0x00-0xFF
	uint8_t	boostType;		//u[Xg^Cv
	uint8_t	bits;			//|[go͂̃rbgZpϐ
	
	sw = psw = 0;
	loopCount = 0;
	swBT =1;		//N̓XCb`ꂽƂɂiboostTypeɍLED_邽߁j
	
	//EEPROMOĨu[Xg^Cvǂݍ
	eeprom_busy_wait();
	boostType = eeprom_read_byte((uint8_t*)ADRS_BOOSTTYPE);
	if (EBT_IDX_END <= boostType)
		boostType = EBT_NORMAL;
	
	//VXeNbNOuݒ
	CLKPR	= 0b10000000;	//NbNlύX
	CLKPR	= 0b00000110;	//64	9.6MHz/64=150kHz
	
	//|[gݒ
	DDRB	= BIT_LED_CTRL | BIT_LED_ROCK | BIT_LED_POP | BIT_LED_CLASSIC;
	PORTB	= BIT_SW;
	
	ACSR	= 0b10000000;	//AiORp[^֎~id͂}邽߁j
	
	while (1)
	{
		//XCb`ꂽꍇ
		if (swBT != 0)
		{
			bits = PORTB & ~BIT_LED_MASK;
			
			switch (boostType)
			{
			case EBT_ROCK:
				bits |= BIT_CTRLA;
				break;
			
			case EBT_POP:
				bits |= (BIT_CTRLA | BIT_CTRLB);
				bits |= BIT_LED_CTRL;
				bits |= BIT_LED_POP;
				break;
			
			case EBT_CLASSIC:
				bits |= BIT_CTRLB;
				break;
			
			default:	//EBT_NORMAL
				break;
			}
			
			PORTB = bits;
			
			//EEPROMɌ݂̃u[Xg^Cv
			eeprom_busy_wait();
			eeprom_write_byte((uint8_t*)ADRS_BOOSTTYPE, boostType);
		}
		
		//XCb`ǂݎ
		swBT = 0;
		if ((++loopCount & 0x08) == 0x08)	//`^OłxɃ[vԊu󂯂
		{
			sw = PINB & BIT_SW;
			if (psw != sw)
			{
				swBT = ~sw & BIT_SW;
				psw = sw;
			}
		}
		
		//XCb`ꂽꍇÃu[Xg^CvɕύX
		if (swBT != 0)
			boostType = (boostType + 1) % EBT_IDX_END;
		
	}	//while()
	
	return 0;
}
